// Include the libraries we need
#include <OneWire.h>
#include <DallasTemperature.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <Adafruit_Sensor.h>
#include <DHT.h>
#include <DHT_U.h>

LiquidCrystal_I2C lcd(0x3f,20,4);  // set the LCD address to 0x27 for a 16 chars and 2 line display

//DHT seting_________________
#define DHTPIN            D6         // Pin which is connected to the DHT sensor.
// Uncomment the type of sensor in use:
#define DHTTYPE           DHT11     // DHT 11 
//#define DHTTYPE           DHT22     // DHT 22 (AM2302)
//#define DHTTYPE           DHT21     // DHT 21 (AM2301)

//dalas sensor_____________
// Data wire is plugged into port 2 on the Arduino 4 esp
#define ONE_WIRE_BUS 2
#define TEMPERATURE_PRECISION 9
#define led 14
//______________________

DHT_Unified dht(DHTPIN, DHTTYPE);

uint32_t delayMS;

//______________________
// parameters
  int analogF = 13;  // analog feq write on PWM
  int minstep = 200;  //fan min rpm
  int maxspeed  = 750; // maxium fan speed 
  int maxspeed2 = 800;  // max speed for 2nd fan
 //int pulseT = 524;  //  was used for testing purpose
  int offset = 50; // if you wish to offset fans speeds so one runs fasteror slower  then the other  to create positive or negative pressure in the building 
  float  DiffTemp = 10;  // temp diff -
  int Mintemp = -20; //
  int mintempfs= 100; // set min temp fan speed once mininium outside temp is reached -- to prevent fan freezing
  float diff = 3; // temp diff between analog and digital out put sensor reads
  int sample =3; // analog sample rate
  int MSdelay= 200; //ms delay between sampling 
//__________________
  
  float  Dtemp ;  //  scalor  for triac steps  
  float  Dtempa;
  float  Mtemp ;   
  float inputT;
  float inputTa;
  float inputD;
  float inputDa;
  float inputD2;
  int pulse; // SSR #1 pulse
  int pulse2; // SSR #2 pulse
  int pulseA; // Pulse average
  int pulseP; // pulse percentage 
  float tempD2;
  float Maxtemp; // start temp for the house  temp house temp
  int humidAdj;  //  sets humidity level to change from high air flow to low airflow when  proper humidity is  reach compared to outside temp
  
 

// Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
OneWire oneWire(ONE_WIRE_BUS);

// analoge sensor config_________
#include <math.h>

double Thermistor(int RawADC) {
 double Temp;
 //Temp = log(10000.0*((1024.0/RawADC-1))); // adjust 10000.0  to get accurate  temp - use other inline if temputer move in opposite direction
  Temp =log(11000.0/(1024.0/RawADC-1)); // for pull-up configuration 
 Temp = 1 / (0.001129148 + (0.000234125 + (0.0000000876741 * Temp * Temp ))* Temp );
 Temp = Temp - 273.15;            // Convert Kelvin to Celcius
 //Temp = (Temp * 9.0)/ 5.0 + 32.0; // Convert Celcius to Fahrenheit
 return Temp;
}

//___________________________
// Pass our oneWire reference to Dallas Temperature. 
DallasTemperature sensors(&oneWire);

// arrays to hold device addresses
DeviceAddress inputa, outputa, inputb, outputb;
//___________________________

void setup()
{
  //Mtemp=(Maxtemp+DiffTemp); // temp reading diff on 
  analogWrite(led, maxspeed);
  pulse= minstep;
  analogWriteFreq(analogF);// adjust this freq to get best preformance form SSR or triac (using MOC3043)
  // start serial port
  Serial.begin(115200);
  Serial.println("HVAC Motor and Temperture controller");
  lcd.init();                      // initialize the lcd 
 // lcd.init();
  // Print a message to the LCD.
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print("HVAC Motor/Temp");
  lcd.setCursor(2,1);
  lcd.print("Controller!");

 dht.begin(); // DHT setup
 sensor_t sensor;
 dht.temperature().getSensor(&sensor);
 dht.humidity().getSensor(&sensor);
 delayMS = sensor.min_delay / 1000;
  // Start up the library
  
  sensors.begin(); // dallas sensors  setup
  
  // locate devices on the bus
  Serial.print("Locating devices...");
  Serial.print("Found ");
  Serial.print(sensors.getDeviceCount(), DEC);
  Serial.println(" devices.");

  // report parasite power requirements
  Serial.print("Parasite power is: "); 
  if (sensors.isParasitePowerMode()) Serial.println("ON");
  else Serial.println("OFF");

  // Assign address manually. The addresses below will beed to be changed
  // to valid device addresses on your bus. Device address can be retrieved
  // by using either oneWire.search(deviceAddress) or individually via
  // sensors.getAddress(deviceAddress, index)
  //insideThermometer = { 0x28, 0x1D, 0x39, 0x31, 0x2, 0x0, 0x0, 0xF0 };
  //outsideThermometer   = { 0x28, 0x3F, 0x1C, 0x31, 0x2, 0x0, 0x0, 0x2 };

  // Search for devices on the bus and assign based on an index. Ideally,
  // you would do this to initially discover addresses on the bus and then 
  // use those addresses and manually assign them (see above) once you know 
  // the devices on your bus (and assuming they don't change).
  // 
  // method 1: by index
  if (!sensors.getAddress(inputa, 0)) Serial.println("Unable to find address for Device 0"); 
  if (!sensors.getAddress(outputa, 1)) Serial.println("Unable to find address for Device 1"); 
  if (!sensors.getAddress(inputb, 2)) Serial.println("Unable to find address for Device 2"); 
 // if (!sensors.getAddress(outputb, 3)) Serial.println("Unable to find address for Device 3"); 

  // method 2: search()
  // search() looks for the next device. Returns 1 if a new address has been
  // returned. A zero might mean that the bus is shorted, there are no devices, 
  // or you have already retrieved all of them. It might be a good idea to 
  // check the CRC to make sure you didn't get garbage. The order is 
  // deterministic. You will always get the same devices in the same order
  //
  // Must be called before search()
  //oneWire.reset_search();
  // assigns the first address found to insideThermometer
  //if (!oneWire.search(insideThermometer)) Serial.println("Unable to find address for insideThermometer");
  // assigns the seconds address found to outsideThermometer
  //if (!oneWire.search(outsideThermometer)) Serial.println("Unable to find address for outsideThermometer");

  // show the addresses we found on the bus
  Serial.print("Device 0 Address: ");
  printAddress(inputa);
  Serial.println();

  Serial.print("Device 1 Address: ");
  printAddress(outputa);
  Serial.println();
  
  Serial.print("Device 2 Address: ");
  printAddress(inputb);
  Serial.println();
  
  sensors.setResolution(inputa, TEMPERATURE_PRECISION);
  sensors.setResolution(outputa, TEMPERATURE_PRECISION);
  sensors.setResolution(inputb, TEMPERATURE_PRECISION);

  Serial.print("Device 0 Resolution: ");
  Serial.print(sensors.getResolution(inputa), DEC); 
  Serial.println();

  Serial.print("Device 1 Resolution: ");
  Serial.print(sensors.getResolution(outputa), DEC); 
  Serial.println();
  
  Serial.print("Device 2 Resolution: ");
  Serial.print(sensors.getResolution(inputb), DEC); 
  Serial.println();
  
}

// function to print a device address
void printAddress(DeviceAddress deviceAddress)
{
  for (uint8_t i = 0; i < 8; i++)
  {
    // zero pad the address if necessary
    if (deviceAddress[i] < 16) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
  }
}

// function to print the temperature for a device
void printTemperature(DeviceAddress deviceAddress)
{
  float tempC = sensors.getTempC(deviceAddress);
  Serial.print("Temp C: ");
  Serial.print(tempC);
  //Serial.print(" Temp F: ");
  //Serial.print(DallasTemperature::toFahrenheit(tempC));
}

// function to print a device's resolution
void printResolution(DeviceAddress deviceAddress)
{
  Serial.print("Resolution: ");
  Serial.print(sensors.getResolution(deviceAddress));
  Serial.println();    
}

// main function to print information about a device
void printData(DeviceAddress deviceAddress)
{
  Serial.print("Device Address: ");
  printAddress(deviceAddress);
  Serial.print(" ");
  printTemperature(deviceAddress);
  Serial.println();
}

/*
 * Main function, calls the temperatures in a loop.
 */
void loop()
 {

  
  // call sensors.requestTemperatures() to issue a global temperature 
  // request to all devices on the bus
  Serial.print("Requesting temperatures...");
  sensors.requestTemperatures();
  Serial.println("DONE");

 
//digital sensors
  float tempF = sensors.getTempC(inputa);  // digital sensor 1  -- outside air temp
  float tempC = sensors.getTempC(outputa); // digital sensor 2  -- outflow air temp 
  float tempE = sensors.getTempC(inputb);  // digital sensor 3  -- misc
//analog sensors  
  float tempD = ((Thermistor(analogRead(0))));   //anlogue sensor 3 -- solar wall temp
//DHT Sensor 
 sensors_event_t event;  
  dht.temperature().getEvent(&event);
Serial.print  ("temp:");Serial.println(event.temperature);
float tempB = event.temperature ;  // digital sensor 1  -- inside air temp
 dht.humidity().getEvent(&event);
Serial.print  ("Humidity: ");Serial.println(event.relative_humidity);
float humid = event.relative_humidity ;  // Humidity inside  

humidAdj= ((tempF - -120)/3);

//Serial.print("humidA ");Serial.println(humidAdj);

//----------- Scaling algorithim  

  Dtemp = (tempD-tempB);
  
 // Serial.print("scalor "); Serial.println(Dtemp);
 
  Mtemp = tempB+DiffTemp;
  inputT= Mtemp - tempB;
  
  // Serial.print("inputT ");Serial.println(inputT); 

  //if (tempB > tempD) { tempD = tempB;}
  inputD= inputT / Dtemp;
  inputD2= inputD;
  
  //Serial.print("inputD ");Serial.println(inputD);
 
  Serial.print("digital temp ");Serial.println(tempB);

  Serial.print("digital temp ");Serial.println(tempC);

  Serial.print("digital temp ");Serial.println(tempE);

  Serial.print("analog temp ");Serial.println(tempD); 

 /* 
  if (inputD <=0) { inputD = 0;}
  if (inputD > 1) { inputD = 1;}
  pulse = 1024*inputD;
    if (pulse < 0) { pulse = 0;}
  if (pulse > 1024) { pulse = 1024;}
  //pulse = (pulse*4);
  if (tempD < (Mtemp)) {pulse=  minstep;}
  if ( pulse > maxspeed) { pulse = maxspeed;}

  */
 Serial.print("pulse 0 -  ");Serial.println(pulse);
  
  if (tempF < Mintemp) {pulse= mintempfs ;}
  analogWrite(led, pulse); // primary write to 1st triac
  
  // analog search for temp and fan speed 
  pulseA=0;
 for (int i=1; i <= sample  ; i++){  // adjust resample rate get best prformance for flow rate
  tempD = ((Thermistor(analogRead(0))));
 delay (MSdelay);
inputTa = (Mtemp-tempD);

 inputDa = (inputTa / Dtemp);

inputD = (inputD + inputDa);

if (tempB > tempD) {inputD = inputD2;}

 if (inputD <=0) { inputD = 0;}
  if (inputD > 1) { inputD = 1;}
  pulse = 1024*inputD;
  
pulse= (1024 - pulse) ;
 if (pulse < minstep) { pulse = minstep;}
  if (pulse > 1024) { pulse = 1024;}
  if (tempD < (Mtemp)) {pulse=minstep;} 
  if (tempD < Mintemp) {pulse=0;}
  if ( pulse > maxspeed) { pulse = maxspeed;}
  if (humid < humidAdj) { pulse= (minstep * 1.5);}
 // analogWrite(led, pulse); // write to 1st triac

  Serial.print("pulse ");Serial.print(i); Serial.print(" -  ");Serial.println(pulse);
  
 pulseA= pulseA+pulse;
  
  }
  
  pulse= pulseA/sample;
  
   pulse2= (pulse+offset); // Fan speed offset for second fan
  
  if (pulse2 < minstep) { pulse2 = minstep;}
  if (pulse2 > maxspeed2) { pulse2 = maxspeed2;}
  analogWrite(led, pulse2);  // write to 2nd triac
//Serial.print("pulse2 ");Serial.println(pulse2);
   pulseP=(100*pulse);
   pulseP=(pulseP/1024);
 
  //LCD Screen print 
  lcd.clear();
  
  lcd.setCursor(0,0);lcd.print("Humidity     "); lcd.print(humid); lcd.print("%");
  lcd.setCursor(0,1);lcd.print("Inside Temp  "); lcd.print(tempB); lcd.print("C");
  lcd.setCursor(0,2);lcd.print("Outside Temp "); lcd.print(tempF); lcd.print("C");
  lcd.setCursor(0,3);lcd.print("Core "); lcd.print(tempD); lcd.print("C FSP ");lcd.print(pulseP); lcd.print("%");

}

